IF EXISTS (SELECT * FROM dbo.SysObjects WHERE id = object_id(N'dbo.AUDIT_upd_RateLevelChannel') AND OBJECTPROPERTY(id, N'IsTrigger') = 1) DROP TRIGGER dbo.AUDIT_upd_RateLevelChannel 
GO
CREATE TRIGGER [dbo].[AUDIT_upd_RateLevelChannel]
ON [dbo].[RateLevelChannel] FOR UPDATE NOT FOR REPLICATION AS
BEGIN
	

	DECLARE 
		@IDENTITY_SAVE			varchar(50),
		@AUDIT_LOG_TRANSACTION_ID	Int,
		@PRIM_KEY			nvarchar(4000),
		@Inserted	    		bit,
 		@ROWS_COUNT				int,
		@FK_UserIdNumber INT,
		@FK_CashBox INT,
		@ProgramPart SMALLINT,
		@TerminalName VARCHAR(50),
		@SystemDateStr VARCHAR(8),
		@SystemDateTime DATETIME

	SET NOCOUNT ON

	Select @ROWS_COUNT=count(*) from inserted
	SET @IDENTITY_SAVE = CAST(IsNull(@@IDENTITY,1) AS varchar(50))

    SELECT TOP 1 @FK_UserIdNumber = FK_UserIdNumber,
	@FK_CashBox = FK_CashBox,
	@ProgramPart = ProgramPart,
	@TerminalName = TerminalName
	FROM PersonnelLogInfo WITH (NOLOCK)
	WHERE spid = @@spid 
	ORDER BY CreateDate DESC

	IF ISNULL(@FK_UserIdNumber, 0) = 0
	  SET @FK_UserIdNumber = 1
	IF ISNULL(@FK_CashBox, -1) <= 0
	  SET @FK_CashBox = -1
	IF ISNULL(@ProgramPart, -1) <= 0
	  SET @ProgramPart = 14 -- ppUnknown from SystemAll
	IF ISNULL(@TerminalName, '') = ''
	  SET @TerminalName = 'Unknown'

    SELECT @SystemDateStr = SystemDate FROM System WITH (NOLOCK) WHERE Number = 1
    SET @SystemDateTime = CONVERT(DATETIME, @SystemDateStr + ' ' + CONVERT(CHAR(8), CURRENT_TIMESTAMP, 108))

	INSERT INTO dbo.AUDIT_LOG_TRANSACTIONS
	(
		TABLE_NAME,
		TABLE_SCHEMA,
		AUDIT_ACTION_ID,
		HOST_NAME,
		APP_NAME,
		MODIFIED_BY,
		MODIFIED_DATE,
		AFFECTED_ROWS,
		FK_UserIdNumber,
		FK_CashBox,
		ProgramPart,
		TerminalName,
		RealDateTime
	)
	values(
		'RateLevelChannel',
		'dbo',
		1,	--	ACTION ID For UPDATE
		CASE 
		  WHEN LEN(HOST_NAME()) < 1 THEN ' '
		  ELSE HOST_NAME()
		END,
		CASE 
		  WHEN LEN(APP_NAME()) < 1 THEN ' '
		  ELSE APP_NAME()
		END,
		SUSER_SNAME(),
		@SystemDateTime,
		@ROWS_COUNT,
		@FK_UserIdNumber,
		@FK_CashBox,
		@ProgramPart,
		@TerminalName,
		GETDATE()
	)	
	
	Set @AUDIT_LOG_TRANSACTION_ID = SCOPE_IDENTITY()
	
	SET @Inserted = 0
	
	If UPDATE([RateLevelChannelId])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[RateLevelChannelId]='+CONVERT(nvarchar(4000), IsNull(OLD.[RateLevelChannelId], NEW.[RateLevelChannelId]), 0), '[RateLevelChannelId] Is Null')),
		    'RateLevelChannelId',
			CONVERT(nvarchar(4000), OLD.[RateLevelChannelId], 0),
			CONVERT(nvarchar(4000), NEW.[RateLevelChannelId], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[RateLevelChannelId], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[RateLevelChannelId], 0)))
			
		FROM deleted OLD Full Outer Join inserted NEW On
			(CONVERT(nvarchar(4000), NEW.[RateLevelChannelId], 0)=CONVERT(nvarchar(4000), OLD.[RateLevelChannelId], 0) or (NEW.[RateLevelChannelId] Is Null and OLD.[RateLevelChannelId] Is Null))
			WHERE (
			
			
				(
					NEW.[RateLevelChannelId] <>
					OLD.[RateLevelChannelId]
				) Or
			
				(
					NEW.[RateLevelChannelId] Is Null And
					OLD.[RateLevelChannelId] Is Not Null
				) Or
				(
					NEW.[RateLevelChannelId] Is Not Null And
					OLD.[RateLevelChannelId] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([Name])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[RateLevelChannelId]='+CONVERT(nvarchar(4000), IsNull(OLD.[RateLevelChannelId], NEW.[RateLevelChannelId]), 0), '[RateLevelChannelId] Is Null')),
		    'Name',
			CONVERT(nvarchar(4000), OLD.[Name], 0),
			CONVERT(nvarchar(4000), NEW.[Name], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[RateLevelChannelId], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[RateLevelChannelId], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[RateLevelChannelId], 0)=CONVERT(nvarchar(4000), OLD.[RateLevelChannelId], 0) or (NEW.[RateLevelChannelId] Is Null and OLD.[RateLevelChannelId] Is Null))
			where (
			
			
				(
					NEW.[Name] <>
					OLD.[Name]
				) Or
			
				(
					NEW.[Name] Is Null And
					OLD.[Name] Is Not Null
				) Or
				(
					NEW.[Name] Is Not Null And
					OLD.[Name] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([FK_OTARequestorId])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[RateLevelChannelId]='+CONVERT(nvarchar(4000), IsNull(OLD.[RateLevelChannelId], NEW.[RateLevelChannelId]), 0), '[RateLevelChannelId] Is Null')),
		    'FK_OTARequestorId',
			CONVERT(nvarchar(4000), OLD.[FK_OTARequestorId], 0),
			CONVERT(nvarchar(4000), NEW.[FK_OTARequestorId], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[RateLevelChannelId], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[RateLevelChannelId], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[RateLevelChannelId], 0)=CONVERT(nvarchar(4000), OLD.[RateLevelChannelId], 0) or (NEW.[RateLevelChannelId] Is Null and OLD.[RateLevelChannelId] Is Null))
			where (
			
			
				(
					NEW.[FK_OTARequestorId] <>
					OLD.[FK_OTARequestorId]
				) Or
			
				(
					NEW.[FK_OTARequestorId] Is Null And
					OLD.[FK_OTARequestorId] Is Not Null
				) Or
				(
					NEW.[FK_OTARequestorId] Is Not Null And
					OLD.[FK_OTARequestorId] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([ChannelType])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[RateLevelChannelId]='+CONVERT(nvarchar(4000), IsNull(OLD.[RateLevelChannelId], NEW.[RateLevelChannelId]), 0), '[RateLevelChannelId] Is Null')),
		    'ChannelType',
			CONVERT(nvarchar(4000), OLD.[ChannelType], 0),
			CONVERT(nvarchar(4000), NEW.[ChannelType], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[RateLevelChannelId], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[RateLevelChannelId], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[RateLevelChannelId], 0)=CONVERT(nvarchar(4000), OLD.[RateLevelChannelId], 0) or (NEW.[RateLevelChannelId] Is Null and OLD.[RateLevelChannelId] Is Null))
			where (
			
			
				(
					NEW.[ChannelType] <>
					OLD.[ChannelType]
				) Or
			
				(
					NEW.[ChannelType] Is Null And
					OLD.[ChannelType] Is Not Null
				) Or
				(
					NEW.[ChannelType] Is Not Null And
					OLD.[ChannelType] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([MultipleRestrictions])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[RateLevelChannelId]='+CONVERT(nvarchar(4000), IsNull(OLD.[RateLevelChannelId], NEW.[RateLevelChannelId]), 0), '[RateLevelChannelId] Is Null')),
		    'MultipleRestrictions',
			CONVERT(nvarchar(4000), OLD.[MultipleRestrictions], 0),
			CONVERT(nvarchar(4000), NEW.[MultipleRestrictions], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[RateLevelChannelId], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[RateLevelChannelId], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[RateLevelChannelId], 0)=CONVERT(nvarchar(4000), OLD.[RateLevelChannelId], 0) or (NEW.[RateLevelChannelId] Is Null and OLD.[RateLevelChannelId] Is Null))
			where (
			
			
				(
					NEW.[MultipleRestrictions] <>
					OLD.[MultipleRestrictions]
				) Or
			
				(
					NEW.[MultipleRestrictions] Is Null And
					OLD.[MultipleRestrictions] Is Not Null
				) Or
				(
					NEW.[MultipleRestrictions] Is Not Null And
					OLD.[MultipleRestrictions] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	-- Watch
	
	-- Lookup
	
	IF @Inserted = 0
	BEGIN
		DELETE FROM dbo.AUDIT_LOG_TRANSACTIONS WHERE AUDIT_LOG_TRANSACTION_ID = @AUDIT_LOG_TRANSACTION_ID
	END
	-- Restore @@IDENTITY Value  
    DECLARE @maxprec AS varchar(2)
    SET @maxprec=CAST(@@MAX_PRECISION as varchar(2))
    EXEC('SELECT IDENTITY(decimal('+@maxprec+',0),'+@IDENTITY_SAVE+',1) id INTO #tmp')
End
